/* =============================================================
	Test 4:  bi-directional transfer, ready mode send
					Scheme
				Node0	Node1
				IRecv	IRecv
				Barrier	Barrier
				RSend	RSend
				Wait	Wait
================================================================ */

#include"transfer.h"


static MPI_Status Statuses[2];
static MPI_Request Requests[2]; 

const char test_description[] = "Bi-directional/Ready mode (4)";

#define comm MPI_COMM_WORLD

void transfer_test_operation(void *sendbuf,void *recvbuf,int msglen,int rank,int TIMES)
{
	int the_other = (rank == 0) ? 1 : 0;
	int i;	
	for(i = 0; i < TIMES; i ++) {
		MPI_Irecv(recvbuf,msglen,MPI_CHAR,the_other,TAG1,comm,&Requests[0]);
		MPI_Barrier(comm);
		MPI_Irsend(sendbuf,msglen,MPI_CHAR,the_other,TAG1,comm,&Requests[1]);
		MPI_Waitall(2,Requests,Statuses);
	}
}
